#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from astra_csp_cryptopro.utils import Utils


class BsdTarArchiver:
    def __init__(self, filepath: str, targetdir: str) -> None:
        self.__filepath = filepath
        self.__target = targetdir

    def create(self) -> None:
        args = ['-C', self.__target, '--options', 'zip:compression=store',
                '-acf', self.__filepath, '--dereference', '.']
        Utils.execute('bsdtar', args)

    def unpack(self) -> None:
        args = ['-xf', self.__filepath, '--directory', self.__target]
        Utils.execute('bsdtar', args)

    def update(self) -> None:
        # Unrecognized archive format
        # args = ['-C', self.__target, '--options', 'zip:compression=store',
        #         '-uf', self.__filepath, '--dereference', '.']
        # Utils.execute('bsdtar', args)
        self.create()
