#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from platform import machine

from PyQt5.QtWidgets import QApplication


translate = QApplication.translate


class CprocspPaths:
    __bin_dir_path = '/opt/cprocsp/bin'
    __arch_sub_paths = {'x86_64': 'amd64',
                        'armv7l': 'arm',
                        'e2k': 'e2k64',
                        'mips': 'mipsel',
                        'mips64': 'mipsel'}

    @classmethod
    def bin_file_path(cls, filename: str) -> str:
        arch = machine()
        try:
            arch_path = cls.__arch_sub_paths[arch]
        except KeyError:
            raise Exception(translate('text', 'Not found "{bin}" binary file for "{arch}" architecture')
                            .format(bin=filename,
                                    arch=arch))

        return '{bin_path}/{arch}/{filename}'.format(bin_path=cls.__bin_dir_path,
                                                     arch=arch_path,
                                                     filename=filename)
